<template>
  <v-menu
    ref="menu"
    v-model="showMenu"
    :close-on-content-click="false"
    :nudge-right="40"
    :return-value.sync="time"
    transition="scale-transition"
    offset-y
    max-width="290px"
    min-width="290px"
  >
    <template #activator="{ on, attrs }">
      <v-text-field
        v-model="time"
        :label="label"
        append-icon="mdi-clock-time-four-outline"
        readonly
        outlined
        v-bind="attrs"
        v-on="on"
      />
    </template>
    <v-time-picker
      v-if="showMenu"
      v-model="time"
      full-width
      scrollable
      :min="min"
      :allowed-minutes="allowedStep"
      @click:minute="$refs.menu.save(time)"
      @input="handleTimeInput"
    />
  </v-menu>
</template>

<script>
import { format, add, isToday } from 'date-fns';

export default {
  name: 'TimePicker',
  props: {
    value: {
      type: Object,
      default: null,
    },
    label: {
      type: String,
      default: 'Hora',
    },
    restrictedTo: {
      type: Date,
      default: () => new Date(),
    },
  },
  data() {
    const now = new Date();
    const time = format(add(now, { hours: 1 }), 'HH:00');
    return {
      now,
      time,
      showMenu: false,
      modal2: false,
    };
  },
  computed: {
    min() {
      if (isToday(this.restrictedTo)) {
        return format(this.now, 'HH:mm');
      }

      return null;
    },
  },
  mounted() {
    this.handleTimeInput(this.time);
  },
  methods: {
    allowedStep: m => m % 5 === 0,
    handleTimeInput(input) {
      const [hours, minutes] = input.split(':');
      this.$emit('input', { hours, minutes });
    },
  },
};
</script>
